## ros-foxy-psen-scan-v2 0.20.0

=== CMakeLists.txt ===
# Copyright (c) 2020-2021 Pilz GmbH & Co. KG
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.5)
project(psen_scan_v2)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

add_compile_options(-std=c++14)
add_compile_options(-Wall)
add_compile_options(-Wextra)
add_compile_options(-Wno-unused-parameter)
add_compile_options(-Werror)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(Boost 1.69)
if(NOT Boost_FOUND)
  find_package(Boost REQUIRED COMPONENTS system filesystem)
endif()
find_package(fmt REQUIRED)

################
## Clang tidy ##
################
# alternative to ament_cmake_clang_tidy which is very time consuming
# to run: catkin_make -DAMENT_ENABLE_CLANG_TIDY=true
# build and install folders have to be deleted before run
if(AMENT_ENABLE_CLANG_TIDY)
  find_program(
    CLANG_TIDY_EXE
    NAMES "clang-tidy"
    DOC "Path to clang-tidy executable"
    )
  if(NOT CLANG_TIDY_EXE)
    message(FATAL_ERROR "clang-tidy not found.")
  else()
    message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
    set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}") # Todo: -header-filter=${PROJECT_NAME}/.*
  endif()
endif()

######################
## Build Standalone ##
######################

set(${PROJECT_NAME}_standalone_sources
  standalone/src/scanner_v2.cpp
  standalone/src/laserscan.cpp
  standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
  standalone/src/data_conversion_layer/start_request.cpp
  standalone/src/data_conversion_layer/start_request_serialization.cpp
  standalone/src/data_conversion_layer/stop_request_serialization.cpp
  standalone/src/data_conversion_layer/monitoring_frame_deserialization.cpp
  standalone/src/data_conversion_layer/diagnostics.cpp
  standalone/src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp
)

add_library(${PROJECT_NAME}_standalone
  ${${PROJECT_NAME}_standalone_sources}
)
target_compile_definitions(${PROJECT_NAME}_standalone
  PUBLIC
  _ROS_BUILD_
)
target_include_directories(${PROJECT_NAME}_standalone
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/standalone/include>
  $<INSTALL_INTERFACE:include>
)
ament_target_dependencies(${PROJECT_NAME}_standalone
  Boost
  fmt
  rcutils
)

###########
## Build ##
###########

set(${PROJECT_NAME}_node_sources
  src/psen_scan_driver.cpp
)

add_executable(${PROJECT_NAME}_node
  ${${PROJECT_NAME}_node_sources}
)
target_include_directories(${PROJECT_NAME}_node
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_link_libraries(${PROJECT_NAME}_node
  ${PROJECT_NAME}_standalone
)
ament_target_dependencies(${PROJECT_NAME}_node
  rclcpp
  sensor_msgs
)

#############
## Install ##
#############

install(DIRECTORY include/ standalone/include/
  DESTINATION include
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(DIRECTORY launch DESTINATION share/${PROJECT_NAME})
install(DIRECTORY config DESTINATION share/${PROJECT_NAME})
install(DIRECTORY urdf DESTINATION share/${PROJECT_NAME})

install(TARGETS
  ${PROJECT_NAME}_node
  ${PROJECT_NAME}_standalone
  DESTINATION lib/${PROJECT_NAME}
)

############
##  Test  ##
############
if(BUILD_TESTING)

  find_package(ament_cmake_clang_format REQUIRED)
  find_package(ament_cmake_xmllint REQUIRED)

  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_ros REQUIRED)
  find_package(console_bridge REQUIRED)
  find_package(ros_testing REQUIRED)

  include_directories(
    include
    standalone/include
    standalone/test/include
    test/include
  )

  ####################
  ##  Linter-Tests  ##
  ####################
  ament_clang_format(CONFIG_FILE ".clang-format")
  ament_xmllint()

  ##################
  ##  Unit-Tests  ##
  ##################
  ament_add_gtest(unittest_new_exceptions
    test/unit_tests/unittest_new_exceptions.cpp
  )

  ament_add_gtest(unittest_raw_processing
    standalone/test/unit_tests/data_conversion_layer/unittest_raw_processing.cpp
  )
  target_link_libraries(unittest_raw_processing
    fmt::fmt
  )

  ament_add_gtest(unittest_start_request
    standalone/test/unit_tests/data_conversion_layer/unittest_start_request.cpp
    standalone/src/data_conversion_layer/start_request.cpp
    standalone/src/data_conversion_layer/start_request_serialization.cpp
  )
  target_link_libraries(unittest_start_request
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_stop_request
    standalone/test/unit_tests/data_conversion_layer/unittest_stop_request.cpp
    standalone/src/data_conversion_layer/stop_request_serialization.cpp
  )

  ament_add_gtest(unittest_scan_range
    standalone/test/unit_tests/util/unittest_scan_range.cpp
  )

  ament_add_gtest(unittest_scanner_configuration
    standalone/test/unit_tests/configuration/unittest_scanner_configuration.cpp
  )
  target_link_libraries(unittest_scanner_configuration
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_tenth_of_degree
    standalone/test/unit_tests/util/unittest_tenth_of_degree.cpp
  )

  ament_add_gmock(unittest_udp_client
    standalone/test/unit_tests/communication_layer/unittest_udp_client.cpp
  )
  target_link_libraries(unittest_udp_client
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_tenth_degree_conversion
    standalone/test/unit_tests/data_conversion_layer/unittest_tenth_degree_conversion.cpp
  )

  ament_add_gtest(unittest_laserscan
    standalone/test/unit_tests/api/unittest_laserscan.cpp
    standalone/src/laserscan.cpp
  )
  target_link_libraries(unittest_laserscan
    fmt::fmt
  )

  ament_add_gtest(unittest_laserscan_conversions
    standalone/test/unit_tests/data_conversion_layer/unittest_laserscan_conversions.cpp
    standalone/src/laserscan.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
  )
  target_link_libraries(unittest_laserscan_conversions
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_laserscan_ros_conversions
    test/unit_tests/unittest_laserscan_ros_conversions.cpp
    standalone/src/laserscan.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
  )
  ament_target_dependencies(unittest_laserscan_ros_conversions
    rclcpp
    sensor_msgs
  )
  target_link_libraries(unittest_laserscan_ros_conversions
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_scanner_reply_msg
    standalone/test/unit_tests/data_conversion_layer/unittest_scanner_reply_msg.cpp
    standalone/src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp
  )
  target_link_libraries(unittest_scanner_reply_msg
    fmt::fmt
  )

  ament_add_gtest(unittest_monitoring_frame_msg
    standalone/test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
    standalone/src/data_conversion_layer/monitoring_frame_deserialization.cpp
  )
  target_link_libraries(unittest_monitoring_frame_msg
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_monitoring_frame_msg_stamped
    standalone/test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg_stamped.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
  )
  target_link_libraries(unittest_monitoring_frame_msg_stamped
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gtest(unittest_monitoring_frame_serialization_deserialization
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/monitoring_frame_deserialization.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
    standalone/test/unit_tests/data_conversion_layer/unittest_monitoring_frame_serialization_deserialization.cpp
    standalone/test/src/data_conversion_layer/monitoring_frame_serialization.cpp
  )
  target_link_libraries(unittest_monitoring_frame_serialization_deserialization
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gmock(unittest_logging
    standalone/test/unit_tests/util/unittest_logging.cpp
  )
  target_link_libraries(unittest_logging
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gmock(unittest_monitoring_frame_diagnostic_message
    standalone/src/data_conversion_layer/diagnostics.cpp
    standalone/test/unit_tests/data_conversion_layer/unittest_monitoring_frame_diagnostic_message.cpp
  )
  target_link_libraries(unittest_monitoring_frame_diagnostic_message
    fmt::fmt
  )

  #########################
  ##  Integration-Tests  ##
  #########################
  ament_add_gmock(integrationtest_udp_client
    standalone/test/integration_tests/communication_layer/integrationtest_udp_client.cpp
    standalone/test/src/communication_layer/mock_udp_server.cpp
  )
  target_link_libraries(integrationtest_udp_client
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_gmock(integrationtest_scanner_api
    standalone/test/integration_tests/api/integrationtest_scanner_api.cpp
    standalone/test/src/communication_layer/mock_udp_server.cpp
    standalone/test/src/communication_layer/scanner_mock.cpp
    standalone/test/src/data_conversion_layer/monitoring_frame_serialization.cpp
    standalone/src/scanner_v2.cpp
    standalone/src/laserscan.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/monitoring_frame_deserialization.cpp
    standalone/src/data_conversion_layer/start_request.cpp
    standalone/src/data_conversion_layer/stop_request_serialization.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
    standalone/src/data_conversion_layer/start_request_serialization.cpp
    standalone/src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp
  )
  target_link_libraries(integrationtest_scanner_api
    ${console_bridge_LIBRARIES}
    fmt::fmt
  )

  ament_add_ros_isolated_gmock(integrationtest_ros_scanner_node
    test/integration_tests/integrationtest_ros_scanner_node.cpp
    standalone/src/laserscan.cpp
    standalone/src/data_conversion_layer/monitoring_frame_msg.cpp
    standalone/src/data_conversion_layer/diagnostics.cpp
  )
  target_compile_definitions(integrationtest_ros_scanner_node
    PUBLIC
    _ROS_BUILD_
  )
  target_link_libraries(integrationtest_ros_scanner_node
    fmt::fmt
  )
  ament_target_dependencies(integrationtest_ros_scanner_node
    rclcpp
    sensor_msgs
  )

  ament_add_ros_isolated_gmock(unittest_ros_parameter_handler
      test/unit_tests/unittest_ros_parameter_handler.cpp
  )
  ament_target_dependencies(unittest_ros_parameter_handler
    rclcpp
  )

  add_ros_test(test/integration_tests/integrationtest_ros_scanner_launch.launch.py)

  ######################
  ##  Hardware-Tests  ##
  ######################

  # See ./hwtest_readme.md for details on the hardware tests.

=== standalone/CMakeLists.txt ===
# Copyright (c) 2020-2021 Pilz GmbH & Co. KG
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.0.2)
project(psen_scan_v2_standalone)

add_compile_options(-std=c++14)
if (UNIX)
  add_compile_options(-Wall)
  add_compile_options(-Wextra)
  add_compile_options(-Wno-unused-parameter)
  add_compile_options(-Werror)
endif (UNIX)
if (WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4") # Turn of warnings
  add_definitions(-DNOMINMAX)
endif (WIN32)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

## System dependencies are found with CMake's conventions
find_package(Boost 1.69) ## Boost::system is header-only since 1.69
if(Boost_FOUND)
  add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY -DBOOST_DATE_TIME_NO_LIB -DBOOST_REGEX_NO_LIB -DBOOST_SYSTEM_NO_LIB)
else()
  find_package(Boost REQUIRED COMPONENTS system)
endif()
find_package(console_bridge REQUIRED)
find_package(fmt REQUIRED)

###########
## Build ##
###########

include_directories(
  include
  ${console_bridge_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

set(${PROJECT_NAME}_sources
  src/scanner_v2.cpp
  src/laserscan.cpp
  src/data_conversion_layer/monitoring_frame_msg.cpp
  src/data_conversion_layer/start_request.cpp
  src/data_conversion_layer/start_request_serialization.cpp
  src/data_conversion_layer/stop_request_serialization.cpp
  src/data_conversion_layer/monitoring_frame_deserialization.cpp
  src/data_conversion_layer/diagnostics.cpp
  src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})

target_link_libraries(${PROJECT_NAME}
  ${Boost_LIBRARIES}
  ${console_bridge_LIBRARIES}
  fmt::fmt
)
target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

add_executable(${PROJECT_NAME}_app main.cpp)
target_link_libraries(${PROJECT_NAME}_app
  ${PROJECT_NAME}
)

###########
## Tests ##
###########
if (BUILD_TESTING)

include(CTest)

# The standalone is included  with add_subdirectory from the top-level ROS CMakeLists.txt
# However the tests are build separately in the top-level and thus should be ignored here.
# If you don't know what ROS is, simply ignore this line.
if(NOT DEFINED catkin_FOUND)

# Download + Install gtest (see https://github.com/google/googletest/blob/master/googletest/README.md)
configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()
execute_process(COMMAND ${CMAKE_COMMAND} --build .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                 ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
                 EXCLUDE_FROM_ALL)

if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include_directories("${gtest_SOURCE_DIR}/include")
endif()

include_directories(
  test/include
  ${GTEST_INCLUDE_DIRS}
)

ADD_EXECUTABLE(unittest_laserscan_conversions test/unit_tests/data_conversion_layer/unittest_laserscan_conversions.cpp)

TARGET_LINK_LIBRARIES(unittest_laserscan_conversions
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_laserscan_conversions
         COMMAND unittest_laserscan_conversions)

ADD_EXECUTABLE(unittest_laserscan test/unit_tests/api/unittest_laserscan.cpp)

TARGET_LINK_LIBRARIES(unittest_laserscan
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_laserscan
         COMMAND unittest_laserscan)

ADD_EXECUTABLE(unittest_logging test/unit_tests/util/unittest_logging.cpp)

TARGET_LINK_LIBRARIES(unittest_logging
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_logging
         COMMAND unittest_logging)


ADD_EXECUTABLE(unittest_monitoring_frame_diagnostic_message test/unit_tests/data_conversion_layer/unittest_monitoring_frame_diagnostic_message.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_diagnostic_message
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_monitoring_frame_diagnostic_message
         COMMAND unittest_monitoring_frame_diagnostic_message)

ADD_EXECUTABLE(unittest_monitoring_frame_msg test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_msg
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_monitoring_frame_msg
         COMMAND unittest_monitoring_frame_msg)

ADD_EXECUTABLE(unittest_monitoring_frame_msg_stamped
               test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg_stamped.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_msg_stamped
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_monitoring_frame_msg_stamped
         COMMAND unittest_monitoring_frame_msg_stamped)

ADD_EXECUTABLE(unittest_monitoring_frame_serialization_deserialization
               test/unit_tests/data_conversion_layer/unittest_monitoring_frame_serialization_deserialization.cpp
               test/src/data_conversion_layer/monitoring_frame_serialization.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_serialization_deserialization
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_monitoring_frame_serialization_deserialization
         COMMAND unittest_monitoring_frame_serialization_deserialization)


ADD_EXECUTABLE(unittest_raw_processing test/unit_tests/data_conversion_layer/unittest_raw_processing.cpp)

TARGET_LINK_LIBRARIES(unittest_raw_processing
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_raw_processing
         COMMAND unittest_raw_processing)


ADD_EXECUTABLE(unittest_scan_range test/unit_tests/util/unittest_scan_range.cpp)

TARGET_LINK_LIBRARIES(unittest_scan_range
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scan_range
         COMMAND unittest_scan_range)


ADD_EXECUTABLE(unittest_scanner_configuration test/unit_tests/configuration/unittest_scanner_configuration.cpp)

TARGET_LINK_LIBRARIES(unittest_scanner_configuration
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scanner_configuration
         COMMAND unittest_scanner_configuration)


ADD_EXECUTABLE(unittest_scanner_reply_msg test/unit_tests/data_conversion_layer/unittest_scanner_reply_msg.cpp)

TARGET_LINK_LIBRARIES(unittest_scanner_reply_msg
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scanner_reply_msg
         COMMAND unittest_scanner_reply_msg)


ADD_EXECUTABLE(unittest_start_request test/unit_tests/data_conversion_layer/unittest_start_request.cpp)

TARGET_LINK_LIBRARIES(unittest_start_request
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_start_request
         COMMAND unittest_start_request)


ADD_EXECUTABLE(unittest_stop_request test/unit_tests/data_conversion_layer/unittest_stop_request.cpp)

TARGET_LINK_LIBRARIES(unittest_stop_request
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_stop_request
        COMMAND unittest_stop_request)


ADD_EXECUTABLE(unittest_tenth_degree_conversion test/unit_tests/data_conversion_layer/unittest_tenth_degree_conversion.cpp)

TARGET_LINK_LIBRARIES(unittest_tenth_degree_conversion
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_tenth_degree_conversion
        COMMAND unittest_tenth_degree_conversion)


ADD_EXECUTABLE(unittest_tenth_of_degree test/unit_tests/util/unittest_tenth_of_degree.cpp)

TARGET_LINK_LIBRARIES(unittest_tenth_of_degree
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_tenth_of_degree
        COMMAND unittest_tenth_of_degree)


ADD_EXECUTABLE(unittest_udp_client test/unit_tests/communication_layer/unittest_udp_client.cpp)

TARGET_LINK_LIBRARIES(unittest_udp_client
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_udp_client
        COMMAND unittest_udp_client)


add_executable(integrationtest_scanner_api
        test/integration_tests/api/integrationtest_scanner_api.cpp
        test/src/communication_layer/mock_udp_server.cpp
        test/src/communication_layer/scanner_mock.cpp
        test/src/data_conversion_layer/monitoring_frame_serialization.cpp
        src/scanner_v2.cpp
        src/laserscan.cpp
        src/data_conversion_layer/monitoring_frame_msg.cpp
        src/data_conversion_layer/monitoring_frame_deserialization.cpp
        src/data_conversion_layer/start_request.cpp
        src/data_conversion_layer/stop_request_serialization.cpp
        src/data_conversion_layer/diagnostics.cpp
        src/data_conversion_layer/start_request_serialization.cpp
        src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp)

target_link_libraries(integrationtest_scanner_api
    ${PROJECT_NAME}
    gtest gmock
)

add_test(NAME integrationtest_scanner_api
        COMMAND integrationtest_scanner_api)


add_executable(integrationtest_udp_client
        test/integration_tests/communication_layer/integrationtest_udp_client.cpp
        test/src/communication_layer/mock_udp_server.cpp)

target_link_libraries(integrationtest_udp_client
    ${PROJECT_NAME}
    gtest gmock
)

add_test(NAME integrationtest_udp_client
        COMMAND integrationtest_udp_client)

endif ()
endif ()

=== debian/changelog ===
ros-foxy-psen-scan-v2 (0.20.0-1focal) focal; urgency=high

  * Port to ros2 foxy (#270)
    
    Rename launch files to *.launch.xml
    
    <string>:8: (WARNING/2) Inline emphasis start-string without end-string.
    
    Update README.md
    
    Add migration notes
    
    Remove delay in signal handler
    
    Introduce _ROS_BUILD_ define in order to choose between ros2 and (pure) cpp logging
    
    Rename ParamMissingOnServer to ParameterNotSet
    
    Allow more flexibel usage of util::Barrier
    
    Add linter clang-format and xmllint
  * Update REAMDE.md
  * Minor improvement of TenthOfDegree
  * Fix scanner destruction problems. Fixes #241
  * Remove dependency on pilz_testutils
  * Always build hardware tests
  * Internal refactorings
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 30 Nov 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.2-1focal) focal; urgency=high

  * Improve performance of standalone part
    
    Introduce RawDataPtr
    
    Write to std::stringstream instead of constructing from std::string
    
    Pass by reference wherever possible
  * Make release build the default
  * Calculate timestamp as the time of the first ray (udp communication time is neglected)
  * API: Add timestamp (nanoseconds since epoch) to LaserScan
  * API: Add scan counter to LaserScan
  * API: remove LaserScan equality operator
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 15 Sep 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.1-1focal) focal; urgency=high

  * Rename urdf links
  * Apply tf prefix equals node name
  * API change: rename launch-file argument prefix->tf_prefix
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 20 Jul 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.0-1focal) focal; urgency=high

  * Set prefix for node name (same value as for tf frames)
  * Introduce bringup.launch for starting only the scanner node
  * Omit closing the data client before destruction. Fixes #212
  * Distance value at angle_end is now included in the scan range
  * Default scan range changed to [-137.4..137.4]deg at 0.1 deg resolution
  * Add options for modifying resolution and enabling intensities
  * Add launchfile option for disabling rviz at startup (default: enable)
  * Handle the infinity codes from the scanner correctly
  * Inform user about current scan range
  * Fix wrong behavior when angle_start and angle_end are equal
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 28 Jun 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.2.1-1focal) focal; urgency=high

  * Fix issues with smaller angle ranges than default range (#183 <https://github.com/PilzDE/psen_scan_v2/issues/183>)
  * Add action for pull request todos (#184 <https://github.com/PilzDE/psen_scan_v2/issues/184>)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Apr 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.2.0-1focal) focal; urgency=high

  * Combine multiple monitoring frames into one scan (#173 <https://github.com/PilzDE/psen_scan_v2/issues/173>)
  * Contributors: Pilz GmbH and Co. KG
  * API change: Driver waits for scan round to complete before sending measurement data by default
  * Introducing new parameter fragmented_scans to switch back to faster fragmented laser_scan messages
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 04 Apr 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.6-1focal) focal; urgency=high

  * Separate ROS and standalone CMakeLists: Closes #169
  * Minor restructuring. Closes #175
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 21 Mar 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.5-1focal) focal; urgency=high

  * Make specifying host ip optional
  * Reorder Readme sections
  * API change: A scan is published only if it contains measurement data
  * Make tests build in standalone with or without ROS installed
  * Document key components in a meaningful expressive way
  * Enable building the standalone lib using MSVC
  * Enable separate building of cpp-lib; extract sources into subproject psen_scan_v2_standalone
  * Renames ScanRange and DefaultScanRange to improve usability
  * Improve namespace hierarchy and move files to respective subfolders
  * Use defaults ports in ScannerConfiguration
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 09 Mar 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.4-1focal) focal; urgency=high

  * Add internal error handling for detecting regressions in the scanner firmware
  * Make specifying udp ports optional
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 12 Jan 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.3-1focal) focal; urgency=high

  * Add ROS noetic support (#103 <https://github.com/PilzDE/psen_scan_v2/issues/103>)
  * Use TYPED_TEST_SUITE instead of deprecated TYPED_TEST_CASE
  * Apply fixes from clang-format (#113 <https://github.com/PilzDE/psen_scan_v2/issues/113>)
  * Spelling measurements (#112 <https://github.com/PilzDE/psen_scan_v2/issues/112>)
  * Directly use fmt lib instead of rosfmt (#108 <https://github.com/PilzDE/psen_scan_v2/issues/108>)
  * Fix clang tidy errors (#109 <https://github.com/PilzDE/psen_scan_v2/issues/109>)
  * Feature/api documentation improvement (#100 <https://github.com/PilzDE/psen_scan_v2/issues/100>)
  * Improve the API documentation
  * Add ROS Noetic support
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 08 Dec 2020 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.2-1focal) focal; urgency=high

  * Add Scanner ports in ScannerConfiguration
  * Switch branching model: Introduce main branch
  * Use github actions
  * Adds missing error bit


=== debian/control ===
Source: ros-foxy-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libboost-system-dev, libconsole-bridge-dev, libfmt-dev, python3-pytest, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format, ros-foxy-ament-cmake-gtest, ros-foxy-ament-cmake-ros, ros-foxy-ament-cmake-xmllint, ros-foxy-ament-index-python, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-launch-testing, ros-foxy-launch-xml, ros-foxy-rclcpp, ros-foxy-rclpy, ros-foxy-rcutils, ros-foxy-ros-testing, ros-foxy-rosbag2-cpp, ros-foxy-rosbag2-storage-default-plugins, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-system-dev, libfmt-dev, ros-foxy-launch-ros, ros-foxy-rclcpp, ros-foxy-rcutils, ros-foxy-robot-state-publisher, ros-foxy-rviz2, ros-foxy-sensor-msgs, ros-foxy-xacro, ros-foxy-ros-workspace
Description: ROS support for the Pilz laser scanner

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-psen-scan-v2//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
